{{- if $.Values.useOracleDB }}
apiVersion: apps/v1
kind: Deployment
metadata:
  namespace: {{ .Release.Namespace }}
  name: standbyplanning-tomcat-deployment
spec:
  selector:
    matchLabels:
      app: standbyplanning-tomcat
  template:
    metadata:
      labels:
        app: standbyplanning-tomcat
      annotations:
        checksum/config1: {{ include (print $.Template.BasePath "/configmap.yaml") . | sha256sum }}
    spec:
      initContainers:
        - name: init-db
          image: ghcr.io/oracle/oraclelinux8-instantclient:21
          imagePullPolicy: IfNotPresent
          env:
            - name: APP_DB_ROLE
              value: BP_{{ .Values.shortNameEnv | upper }}
            - name: ORACLE_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: oracle-secrets
                  key: ORACLE_DBA_PASSWORD
          command: ["sqlplus", "system/$(ORACLE_PASSWORD)@(DESCRIPTION=(ADDRESS=(PROTOCOL=TCP)(Host=oracle-svc.{{ .Values.sharedEnvironment }}.svc.cluster.local)(Port=1521))(CONNECT_DATA=(SERVICE_NAME=XEPDB1)))", "@/sql/initOracleDB.sql", "$(APP_DB_ROLE)", "bp"]
          volumeMounts:
            - name: config-volume
              mountPath: /sql/initOracleDB.sql
              subPath: initOracleDB.sql
      containers:
        - image: "{{ .Values.image.repository }}:{{ .Values.image.tag }}"
          imagePullPolicy: Always
          name: standbyplanning-tomcat
          env:
            # - name: JAVA_OPTS
            #   value: -Dorg.apache.tomcat.util.digester.PROPERTY_SOURCE=org.apache.tomcat.util.digester.EnvironmentPropertySource -Dorg.apache.tomcat.util.digester.REPLACE_SYSTEM_PROPERTIES=true
            - name: JAVA_TOOL_OPTIONS
              value: "-agentlib:jdwp=transport=dt_socket,address=5000,server=y,suspend=n"
            #### Database ####
            ## Oracle ##
            - name: DB_PLATTFORM
              value: org.eclipse.persistence.platform.database.OraclePlatform
            - name: APP_DB_DRIVER
              value: oracle.jdbc.OracleDriver
            - name: APP_DB_ROLE
              value: BP_{{ .Values.shortNameEnv | upper }}
            - name: APP_DB_PASSWORD
              value: bp
            - name: DB_SCHEMA
              value: $(APP_DB_ROLE)
            - name: DATASOURCE_URL
              value: jdbc:oracle:thin:@//oracle-svc.{{ .Values.sharedEnvironment }}.svc.cluster.local/XEPDB1
            #### Misc ####
            - name: APP_FRONTEND_URL
              value: "{{ .Values.branchSubdomain }}ber.{{ .Values.rootEnvironment }}.{{ .Values.ingressDomain }}"
          ports:
            - containerPort: 5000
              name: "jvm-debug"
            - containerPort: 8080
          volumeMounts:
            - name: config-volume
              mountPath: /usr/local/tomcat/webapps/spbe/WEB-INF/classes/application.properties
              subPath: application.properties
            - name: config-volume
              mountPath: /usr/local/tomcat/webapps/spbe/WEB-INF/applicationContext-persistence.xml
              subPath: applicationContext-persistence.xml
            - name: config-volume
              mountPath: /opt/openkdg/mail.properties
              subPath: mail.properties
      volumes:
        - name: config-volume
          configMap:
            name: standbyplanning-config
---
apiVersion: v1
kind: Service
metadata:
  namespace: {{ .Release.Namespace }}
  name: standbyplanning-service
spec:
  selector:
    app: standbyplanning-tomcat
  ports:
    - protocol: TCP
      port: 80
      targetPort: 8080
{{- end }}